<?php
/**
 * ait.class.php information page
 * 
 * Contains 'Adaptive IP Tracking' class .
 *
 * @author evilsocket <evilsocket@gmail.com>
 * @copyright Copyleft (c) 2007, evilsocket
 */

/**
 * Includes escore.php to use main system functions .
 */ 
include_once "escore.php"; 

/**
 * The 'Adaptive IP Tracking' class .
 *
 * @package AIT
 */
class AIT
{
	/**
	 * Address to track .
	 *
	 * @access private
	 * @var string
	 */
	var $address;
	
	/**
	 * Class constructor, all the ai-tracking is made creating the object by this .
	 *
	 * @param bool $alarm alarm flag of the main system .
	 * @param string $address ip address to create tracking of .
	 * @see evilsentienl.class.php
	 */
	function AIT( $alarm, $address ){
		$this->address = $address;
		/* start tracking */
		if( $alarm == true ){			
			$this->track(true);
		}
		else{
			/* check for an existing tracking of this ip */
			if( es_is_tracked($this->address) == true ){
				$this->track(false);
			}
		}
	}
	
	/**
	 * Updates the log file .
	 *
	 * @access private
	 * @param bool $alarm alarm flag
	 * @see AIT::AIT()
	 */
	function track( $alarm ){
		es_dispatch_event( "on_ai_tracking", $this->address, $alarm );
		es_add_track( $this->address, date("d.m.Y H:i:s"), $alarm, es_get_url() );
	}
}
?>