<?php
/**
 * functions.php evilsentinel's functions file .
 * 
 * Contains some useful functions used by evilsentinel system .
 *
 * @author evilsocket <evilsocket@gmail.com>
 * @copyright Copyleft (c) 2007, evilsocket
 */

/**
 * Just in case :P
 */
error_reporting(E_ERROR | E_PARSE);

include_once "esconfig.php";

/* creates the main mysql connection object */
$es_db = es_db_connect($es_db_host,$es_db_user,$es_db_pass,$es_db_name);


$es_settings 
= 
array( 
		'es_version'         => "1.0.9",
	   
		'es_filter_get'      => (es_setting_get("filter_get")     == "1" ? true : false),
		'es_filter_post'     => (es_setting_get("filter_post")    == "1" ? true : false),
		'es_filter_cookie'   => (es_setting_get("filter_cookie")  == "1" ? true : false),
	   			
		'es_filter_referer'  => (es_setting_get("filter_referer") == "1" ? true : false),
	    'es_referer_trigger' => es_setting_get("referer_trigger"),
	    
		'es_email_notify'    => (es_setting_get("email_notify")   == "1" ? true : false),
		'es_notify_email'    => es_setting_get("notify_email"),

		'es_admin_user'		 => es_setting_get("admin_user"),
		'es_admin_hash'      => es_setting_get("admin_hash"),

		'es_esclusion_list'  => es_setting_get("esclusion_list"),

		'es_ip_tracking'     => (es_setting_get("ip_tracking")    == "1" ? true : false),

		'es_events_array'    => array( 'on_main' 		 		   => array(),
									   'on_filtering_start' 	   => array(),
									   'on_filtering_end'  		   => array(),
									   'on_alarm_state'    		   => array(),
									   'on_lock_system'    		   => array(),
									   'on_notify_report'  		   => array(),
									   'on_ai_tracking'     	   => array(),
									   'on_admin_render_track_row' => array()
									 ),
		
		'es_rules'			 => es_load_rules()
);

/**
 * Load rules from es_rules table .
 *
 * @return bool|mixed false if some error occurred, else array of rules rows .
 */
function es_load_rules(){

	$xss = (es_setting_get("filter_xss") == "1" ? true : false);
	$rfi = (es_setting_get("filter_rfi") == "1" ? true : false);
	$lfi = (es_setting_get("filter_lfi") == "1" ? true : false);
	$sql = (es_setting_get("filter_sql") == "1" ? true : false);

	if( !($xss || $rfi || $lfi || $sql) ){
		/* return empty array */
		return array();
	}

	$query = "SELECT * FROM es_rules WHERE type IN (";

	if($xss){ $query .= "'xss'";  }
	if($rfi){ $query .= ",'rfi'"; }
	if($lfi){ $query .= ",'lfi'"; }  
	if($sql){ $query .= ",'sql'"; } 

	$query .= ")";

	$result = @mysql_query( $query );
	
	if (!$result){
		echo mysql_error();
		return false;
	} 
	else{		
		$rows = array();
		while( ($row = @mysql_fetch_assoc($result)) ){
			$rows[] = $row;
		}

		return $rows;
	}
}

/**
 * Check if a given address is AI-Tracked .
 *
 * @param string $address the address to check .
 * @return bool false if some error occurred or if address it's not tracked, else true .
 */
function es_is_tracked($address){
	$result = @mysql_query( "SELECT id FROM es_trackings WHERE address='$address'" );
	
	if (!$result){
		echo mysql_error();
		return false;
	} 
	else{		
		return ( @mysql_num_rows($result) > 0 ? true : false );
	}
}

/**
 * Add an AI-Track into the database .
 *
 * @param string $address ip to track .
 * @param string $datetime date and time of the track .
 * @param bool   $alarm have the request activated an alarm ?
 * @param string $request http request .
 */
function es_add_track($address,$datetime,$alarm,$request){
	@mysql_query( "INSERT INTO es_trackings (datetime,address,alarm,request) VALUES " .
				  "('$datetime','$address',".($alarm ? 1 : 0).",'".mysql_real_escape_string($request)."')" );		
}

/**
 * Save attack information into the database .
 *
 * @param string $datetime date and time of the attack .
 * @param string $address ip address of the attacker .
 * @param string $host host name (ip resolution) of the attacker .
 * @param string $referer http referer of the attacker .
 * @param string $agent http user agent of the attacker .
 * @param string $description description of the attack .
 * @return bool|string false if some error occurred, else the string value of the setting .
 */
function es_log_attack($datetime,$address,$host,$referer,$agent,$description){
	@mysql_query( "INSERT INTO es_logs (datetime,ip,host,referer,agent,description) VALUES ('$datetime','$address','$host','$referer','$agent','$description')" );	
}

/**
 * Read a value from settings table .
 *
 * @param string $name the value to read .
 * @return bool|string false if some error occurred, else the string value of the setting .
 */
function es_setting_get( $name ){
	return es_db_get("es_settings",$name);
}

/**
 * Set a value into settings table .
 *
 * @param string $name the name of the setting to update .
 * @param string $value the value to put in the setting .
 * @return bool|string false if some error occurred, else the string value of the setting .
 */
function es_setting_set( $name, $value ){
	return es_db_set("es_settings",$name,$value);
}

/**
 * Count rows in a table .
 *
 * @param string $table the table to count rows from .
 * @return int rows counted .
 */
function es_db_count( $table ){
	$result = @mysql_query( "SELECT * FROM $table" );
	
	if (!$result){
		echo mysql_error();
		return false;
	} 
	else{		
		return @mysql_num_rows($result);
	}
}

/**
 * Check is $value is numeric .
 *
 * @param string $value the parameter to check .
 * @return bool true if $value is numeric, else false .
 */
function es_isnum($value) {
	return (preg_match("/^[0-9]+$/", $value));
} 

/**
 * Read a value from a table .
 *
 * @param string $table the table name to read from .
 * @param string $key the column name to read from .
 * @return bool|string false if some error occurred, else the string value of the column .
 */
function es_db_get( $table, $key ) {
	$result = @mysql_query( "SELECT $key FROM $table" );
	
	if (!$result){
		echo mysql_error();
		return false;
	} 
	else{		
		$row = @mysql_fetch_assoc($result);
		return $row[$key];
	}
}

/**
 * Update a value in a table .
 *
 * @param string $table the table name to update .
 * @param string $key the column name to update .
 * @param string $value the new value to write .
 */
function es_db_set( $table, $key, $val ){
	if( es_isnum($val) ){
		$query = "UPDATE $table SET $key=$val";
	}
	else{
		$query = "UPDATE $table SET $key='$val'";
	}
	
	@mysql_query( $query );
}

/**
 * Creates the connection with the database .
 *
 * @param string $db_host hostname of the mysql server .
 * @param string $db_user username of the mysql server .
 * @param string $db_pass password of the mysql server .
 * @param string $db_name name of the database .
 */
function es_db_connect($db_host, $db_user, $db_pass, $db_name) {
	$db_connect = @mysql_connect($db_host, $db_user, $db_pass);
	$db_select  = @mysql_select_db($db_name);
	if (!$db_connect) {
		die("<div style='font-family:Verdana;font-size:11px;text-align:center;'><b>Unable to establish connection to MySQL</b><br>".mysql_errno()." : ".mysql_error()."</div>");
	} elseif (!$db_select) {
		die("<div style='font-family:Verdana;font-size:11px;text-align:center;'><b>Unable to select MySQL database</b><br>".mysql_errno()." : ".mysql_error()."</div>");
	}
}

/**
 * Checks if at least one of the filters is active .
 *
 * @return bool returns true if at least one of the filters is active, else false . 
 */
function es_is_active(){
	global $es_settings;
	return ( $es_settings['es_filter_get']     || $es_settings['es_filter_post'] || 
			 $es_settings['es_filter_session'] || $es_settings['es_filter_cookie']
           );
}

/**
 * Returns the number of loaded filters .
 *
 * @return int returns the array count of loaded filters . 
 */
function es_loaded_filters(){
	return es_db_count("es_rules");
}

/**
 * Checks if calling page is in the '$es_esclusion_list' esclusion list .
 *
 * @return bool true if page is in the list, else false . 
 * @see main.php
 */
function es_is_escluded_page(){
	global $es_settings;
	
	$ex_list = explode( ",", $es_settings['es_esclusion_list'] );

	foreach( $ex_list as $escluded ){
		if( @eregi( trim($escluded), $_SERVER['PHP_SELF'] ) ){
			return true;
		}
	}
	
	return false;
}

/**
 * Prints the report contained in the $_SESSION object .
 *
 * @param string $newline character to use for as new line char, default <br> . 
 * @see lockpage.php
 */
function es_echo_session_report( $newline = "<br>" ){
	@session_start();
			
	if( !isset($_SESSION) || !isset($_SESSION["evilsentinel_report"]) ){
		Header( "Location: /index.php" );
		die();
	}
	else{				
		foreach( $_SESSION["evilsentinel_report"] as $line ){
			echo htmlentities($line).$newline;
		}
	}
}

/**
 *Sets the report in the $_SESSION object .
 *
 * @param mixed $data report data to fill session with . 
 * @see EvilSentinel::lock_system()
 */
function es_set_session_report( $data ){
	@session_start();
	$_SESSION["evilsentinel_report"] = $data;
}

/**
 * Creates a directory and sets its attributes .
 *
 * @param string $path directory to create . 
 * @param int $mode how to chmod the directory, default 777.
* @return bool true if creation went ok, else false . 
 */	
function es_create_path( $path, $mode = 0777 ){
	$dirs  = explode(DIRECTORY_SEPARATOR , $path);
	$path  = '.';
	foreach( $dirs as $dir ){
		$path .= DIRECTORY_SEPARATOR.$dir;
		if(!is_dir($path) && !mkdir($path, $mode)){
			return false;
		}
	}
	return true;
}

/**
 * Recostructs the url that user is browsing .
 *
 * @return string the url the user is browsing . 
 */	
function es_get_url(){
	$url = "http://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
	foreach( $_GET as $key => $val ){
		$url .= "?$key=$val";
	}
	return $url;
}

/**
 * Sends an email .
 *
 * @param string $rcpt email of the receiver . 
 * @param string $subj subject of the email to send . 
 * @param string|mixed $data data to fill the body with . 
 */
function es_sendmail( $rcpt, $subj, $data ){
	$body = "";
	
	if( is_array($data) == true ){
		foreach( $data as $line ){
			$body .= "$line\n";
		}
	}
	else{
		$body = $data;
	}
	
	@mail( $rcpt, $subj, $body, "From: evilsentinel@evilsocket.net\nX-Mailer: evilsentinel\n" );	
}

/**
 * Sends an html email report .
 *
 * @param string $rcpt email of the receiver . 
 * @param string $subj subject of the email to send . 
 * @param string|mixed $data html report data . 
 * @return bool true if report successfully sent, else false .
 */
function es_send_report( $rcpt, $subj, $data ){		  
	$headers  = "From: evilsentinel@evilsocket.net\r\n";
    $headers = "Content-type: text/html\r\n";
	return mail( $rcpt, $subj, $data, $headers );	
}

/**
 * Concacts the right relative path to '$path' searching '$hookfile' to state script position .
 *
 * @param string $path the path to append relatives to . 
 * @param string $hookfile file to search to find relative path, default evilsentinel/main.php . 
 * @return string relative path . 
 */
function es_relative_path( $path, $hookfile = "evilsentinel/main.php" ){
	/* search for correct relative path starting from $path */
	$level = "";
	while(!file_exists($level.$hookfile)){ 
		$level .= "../"; 
	}
	
	return $level.$path;
}

/**
 * Checks if sent admin credentials are right .
 *
 * @param string $uname admin user name . 
 * @param string $passw admin password . 
 * @return bool true if credentials are right, else false . 
 */
function es_checklogin( $uname, $passw ){
	global $es_settings;
	return ($uname == $es_settings['es_admin_user'] && md5($passw) == $es_settings['es_admin_hash']);
}

/**
 * Checks user is logged as admin .
 *
 * @return bool true if user is logged, else false . 
 */
function es_islogged(){
	@session_start(); 
	if( !isset($_SESSION["es_uname"]) || !isset($_SESSION["es_passw"]) ){
		return false;
	}
	
	return es_checklogin( $_SESSION["es_uname"], $_SESSION["es_passw"] );
}

/**
 * Fills the session with admin login credentials .
 *
 * @param string $uname admin user name . 
 * @param string $passw admin password . 
 */
function es_dologin( $uname, $passw ){
	@session_start(); 
	$_SESSION["es_uname"] = $uname;
	$_SESSION["es_passw"] = $passw;
}

/**
 * Clear the session from admin login credentials .
 */
function es_dologout(){
	@session_start();
	unset($_SESSION["es_uname"]);
	unset($_SESSION["es_passw"]);
}

/**
 * Load plugins from default directory .
 */
function es_load_plugins(){
	$dir = es_relative_path( "evilsentinel/plugins/" );
	
	if( file_exists($dir) == true ){
		if($handle = @opendir($dir)){
			while(($file = @readdir($handle))) {
				if( $file[0] != '.' && @eregi( "\.php", $file ) ){
					/* check if plugin is enabled */
					if( eregi( "\[disabled\]", $file ) == false ){
						include_once("$dir/$file");
					}
				}
			}
		}
	}
}

/**
 * Check if a specific event has at least one registered handler .
 *
 * @param string $event_name the name of event, set to '*' to hook every event . 
 * @return bool true if the handler is registered, else false . 
 */
function es_is_registered_hook( $event_name ){
	global $es_settings;
	
	if( isset($es_settings['es_events_array']) ){
		if( isset($es_settings['es_events_array'][$event_name]) && (count($es_settings['es_events_array'][$event_name]) > 0) ){
			return true;
		}	
	}
		
	return false;
}

/**
 * Add an handler for a specific system event .
 *
 * @param string $event_name the name of event, set to '*' to hook every event . 
 * @param string $handler name of a callable handler . 
 */
function es_register_hook( $event_name, $handler ){
	global $es_settings;
	
	if( $event_name != "*" ){
		$es_settings['es_events_array'][$event_name][] = $handler;
	}
	else{
		foreach( $es_settings['es_events_array'] as $event => $h ){
			es_register_hook( $event, $handler );
		}
	}
}

/**
 * Dispatch ad event among the handlers vector .
 *
 * @param string $event_name the name of event . 
 * @param mixed ... other args to be passed to the handler . 
 */
function es_dispatch_event( $event_name ){
	global $es_settings;
	
	$handle_args = array_slice( func_get_args(), 1 );
	
	if( isset($es_settings['es_events_array'][$event_name]) ){
		foreach( $es_settings['es_events_array'][$event_name] as $handler ){
			if( is_callable($handler) ){
				/* force pass-By-Ref hack */
				$refs  = array();
				for( $i = 0; $i < count($handle_args); $i++ ){
					$refs[] =& $handle_args[$i];
				}
				
				call_user_func_array( $handler, $handle_args );
			}
		}
	}
}

/**
 * Delete a plugin .
 *
 * @param string $name name of the plugin file . 
 * @return bool true on success, else false . 
 */
function es_delete_plugin( $name ){
	$dir    = es_relative_path( "evilsentinel/plugins/" );
	$plugin = $dir.$name;
	
	if( file_exists($plugin) ){	
		@unlink( $plugin );
		return true;
	}
	else{
		return false;
	}
}

/**
 * Enable or disable a plugin .
 *
 * @param string $name name of the plugin file . 
 * @param string $status on or off . 
 * @return bool true on success, else false . 
 */
function es_set_plugin_status( $name, $status ){
	$dir    = es_relative_path( "evilsentinel/plugins/" );
	$plugin = $dir.$name;
	
	if( file_exists($plugin) ){
		$renameto = ((eregi("\[enabled\]",$plugin) || eregi("\[disabled\]",$plugin)) ? $plugin : str_replace( ".php", "[enabled].php", $plugin ));
		switch($status){
			case "on"  : $renameto = str_replace( "[disabled]", "[enabled]", $renameto ); break;
			case "off" : $renameto = str_replace( "[enabled]", "[disabled]", $renameto ); break;
		}
		
		@rename( $plugin, $renameto );
		
		return true;
	}
	else{
		return false;
	}
}

/**
 * Get an array with plugins informations .
 *
 * @return mixed an array of array( file, name, size, status ) .  
 */
function es_get_plugins(){
	$dir 	 = es_relative_path( "evilsentinel/plugins/" );
	$plugins = array();
	
	if( file_exists($dir) == true ){
		if($handle = @opendir($dir)){
			while(($file = @readdir($handle))) {
				if( $file[0] != '.' && @eregi( "\.php", $file ) ){
					$name   = str_replace( "[enabled]", "", str_replace( "[disabled]", "", str_replace( ".php", "", $file ) ) );
					$size   = @filesize("$dir/$file");
					$status = (eregi( "\[disabled\]", $file ) ? "disabled" : "enabled");
					$plugins[] = array( 'file' => $file, 'name' => $name, 'size' => $size, 'status' => $status );
				}
			}
		}
	}
	
	return $plugins;
}
?>